
$Pref::PropifyWand::AdminOnly = true;
$Pref::PropifyWand::MaxBricks = 5000;
$Pref::PropifyWand::SelectionTimeout = 0;

$Pref::PropifyWand::HighlightColor = getClosestPaintColor("1 0.5 0 1");

function createBrickGroup(%BL_ID)
{
	if(strPos(%BL_ID, "Brickgroup") >= 0)
		return -1;

	if(isObject("Brickgroup_" @ %BL_ID))
		return nameToID("Brickgroup_" @ %BL_ID);

	%group = new SimGroup("Brickgroup_" @ %BL_ID)
	{
		client = -1;
		bl_id = %BL_ID;
		name = "\c1BL_ID: " @ %BL_ID;
		QuotaObject = GlobalQuota;
		doNotDelete = 1;
	};
	MainBrickgroup.add(%group);
	return %group;
}

function serverCmdSetPropifyWandMaxBricks(%cl, %i)
{
	if (!%cl.isSuperAdmin)
		return;

	if (%i $= "" || %i == $Pref::PropifyWand::MaxBricks)
	{
		messageClient(%cl, 'MsgUploadStart', "\c6The current max bricks is \c3" @ $Pref::PropifyWand::MaxBricks);
		return;
	}
	if (!isInteger(%i))
	{
		messageClient(%cl, 'MsgUploadEnd', "\c6\"\c3" @ %i @ "\c6\" is not a valid number!");
		return;
	}


	messageAll('MsgUploadStart', "\c3" @ %cl.name @ "\c6 set the max bricks of the propify wand to " @ %i);
	$Pref::PropifyWand::MaxBricks = %i;
}

function serverCmdSetPropWandMaxBricks(%cl, %i)
{
	serverCmdSetPropifyWandMaxBricks(%cl, %i);
}

datablock particleData(PropifyWandExplosionParticle:WandExplosionParticle) {
	colors[0]          = "1 0.7 0.3 0.9";
	colors[1]          = "1 0.5 0.2 0.7";
	colors[2]          = "1 0.4 0 0.5";
	textureName        = "base/data/particles/chunk";
};

datablock particleEmitterData(PropifyWandExplosionEmitter:WandExplosionEmitter) {
	particles        = PropifyWandExplosionParticle;
};

datablock explosionData(PropifyWandExplosion:WandExplosion) {
	emitter[0]       = PropifyWandExplosionEmitter;
	lightStartColor  = "1 0.4 0 1";
};

datablock projectileData(PropifyWandProjectile:WandProjectile) {
	explosion        = PropifyWandExplosion;
};

datablock particleData(PropifyWandParticleA:WandParticleA) {
	colors[0]          = "1 0.5 0 0.9";
	colors[1]          = "1 0.2 0 0.7";
	colors[2]          = "1 0.4 0.4 0.5";
	textureName        = "base/data/particles/chunk";
};

datablock particleEmitterData(PropifyWandEmitterA:WandEmitterA) {
	particles        = PropifyWandParticleA;
};

datablock particleData(PropifyWandParticleB:WandParticleB) {
	colors[0]          = "1 0.6 0 0.9";
	colors[1]          = "1 0.2 0 0.7";
	colors[2]          = "1 0.4 0.3 0.5";
	textureName        = "base/data/particles/dot";
};

datablock particleEmitterData(PropifyWandEmitterB:WandEmitterB) {
	particles        = PropifyWandParticleB;
};

datablock itemData(PropifyWandItem : WandItem) {
   className       = "ItemData"; //stop creating errors b-baka
	colorShiftColor = "1 0.5 0 1";
	image           = "PropifyWandImage";
	uiName          = "Propify Wand";
};

datablock shapeBaseImageData(PropifyWandImage : wandImage) {
	projectile = PropifyWandProjectile;
	showBricks = true;
	colorShiftColor = "1 0.5 0 1";
	item = PropifyWandItem;
	stateEmitter[1] = PropifyWandEmitterA;
	stateEmitter[3] = PropifyWandEmitterB;
};

function PropifyWandImage::onStopFire(%this,%player)
{
	%player.stopThread(2);
}

function PropifyWandImage::onFire(%this,%player)
{
	%player.playThread(2,armAttack);
	%start = %player.getEyePoint();
	%end = vectorAdd(%player.getEyePoint(),VectorScale(%player.getEyeVector(),20));
	%masks = $TypeMasks::FxBrickAlwaysObjectType;
	%ray = ContainerRayCast(%start,%end,%masks,%player);
	%hit = firstWord(%ray);
	%pos = getWords(%ray, 1, 3);
	if(isObject(%hit))
	{
		%p = new Projectile()
		{
			datablock = %this.projectile;
			initialPosition = %pos;
		};
		%p.explode();
		if(%hit.getClassName() !$= "FxDtsBrick")
			return;
		if(!%player.client.isAdmin)
		{
			commandToClient(%player.client,'centerPrint',"<color:FF9900>You must be an \c3Admin<color:FF9900> to use the <color:ffa500>Propify Wand",3);
			return;
		}

		if(%hit.getGroup().bl_id == 888999)
		{
			commandtoclient(%player.client,'centerPrint',"<color:FF9900>These bricks are already converted to prop bricks.",3);
			return;
		}

		%length = $Pref::PropifyWand::SelectionTimeout * 1000;
		if(getSimTime() - %player.lastBGWandTime < %length)
		{
			messageClient(%player.client,'MsgPlantError_Flood');
			%timeout = getSimTime() - %player.lastBGwandTime;
			%timeout = %length - %timeout;
			%timeout /= 1000;
			%timeout = mCeil(%timeout);
			%timeout = %timeout @ " <color:FF9900>" @ (%timeout > 1 ? "seconds":"second");
			commandtoClient(%player.client,'centerprint',"<color:FF9900>You must wait \c3" @ %timeout @ "<color:FF9900> before selecting again",3);
			return;
		}
		%stack = %hit.getBGStack(%player);
		%stack.numBricks = %stack.getCount();
		%b = (%stack.numbricks != 1  ? "bricks":"brick");
		%brickGroup = "Brickgroup_888999";
		if(!isObject(%brickgroup))
		{
			%brickgroup = createBrickGroup(888999);
		}
		%player.lastBGWandTime = getSimTime();

		for(%i=0;%i<%stack.numBricks;%i++)
		{
			%brick = %stack.getObject(%i);
			%name = %brick.getName();
			%group = %brick.getGroup();
			%groupC = %group.NTObjectCount[%name];
			%group.remove(%brick);
			if(%brick.getName() !$= "")
			{
				for(%a=0;%a<%groupC;%a++)
				{
					%br = %group.NTObject[%name, %a];
					if(%br == %brick && isObject(%br))
					{
						%group.NTObject[%name, %a] = "0";
						%group.NTObjectCount[%name]--;
					}
				}

				%brCount = 0;
				for(%a=0;%a<%groupC;%a++)
				{
					%br = %group.NTObject[%name, %a];
					if(isObject(%br))
					{
						%br[%a] = %br;
						%brCount++;
					}
				}

				for(%a=0;%a<%brCount;%a++) //Reshift the brick name count
				{
					%br = %br[%a];
					%group.NTObject[%name, %a] = %br;
				}

				//Now to add the brick

				%foundName = 0;
				for(%j=0;%j<mFloor(%brickGroup.NTNameCount);%j++)
				{
					if(%brickGroup.NTName[%j] $= %name)
						%foundName = 1;
				}

				if(!%foundName)
				{
					%brickgroup.NTName[mFloor(%brickgroup.NTNameCount)] = %name;
					%brickgroup.NTNameCount++;
				}

				%foundDuplicate = 0;
				for(%z=0;%z<mFloor(%brickgroup.NTObjectCount[%name]);%z++)
				{
					if(%brickgroup.NTObject[%name, %z] == %brick)
						%foundDuplicate = 1;
				}

				if(!%foundDuplicate)
				{
					%brickgroup.NTObject[%name, mFloor(%brickgroup.NTObjectCount[%name])] = %brick;
					%brickgroup.NTObjectCount[%name]++;
				}
			}

			if(%brick.getDatablock().specialBrickType $= "SpawnPoint")
			{
				%groupSC = %group.spawnBrickCount;

				for(%a=0;%a<%groupSC;%a++)
				{
					%br = %group.spawnBrick[%a];
					if(%br == %brick && isObject(%br))
					{
						%group.spawnBrick[%a] = "0";
						%group.spawnBrickCount--;
					}
				}

				%brCount = 0;
				for(%a=0;%a<%groupSC;%a++)
				{
					%br = %group.spawnBrick[%a];
					if(isObject(%br))
					{
						%br[%a] = %br;
						%brCount++;
					}
				}

				for(%a=0;%a<%brCount;%a++) //Reshift the brickgroup spawn count
				{
					%br = %br[%a];
					%group.spawnBrick[%a] = %br;
				}

				%foundDuplicate = 0;
				for(%z=0;%z<mFloor(%brickgroup.spawnBrickCount);%z++)
				{
					if(%brickgroup.NTObject[%name, %z] == %brick)
						%foundDuplicate = 1;
				}

				if(!%foundDuplicate)
				{
					%brickgroup.spawnBrick[mFloor(%brickgroup.spawnBrickCount)] = %brick;
					%brickgroup.spawnBrickCount++;
				}
			}
			%brickgroup.add(%brick);
		}
		centerprint(%player.client,"<color:ffa500>Propify Wand<br><color:ffa500>" @ %stack.numBricks SPC %b @ "<color:FF9900> converted to prop bricks",3);
		if(%stack.err $= "Limit")
			messageClient(%player.client,'MsgPlantError_Limit');
	}
}

function FxDtsBrick::getBGStack(%brick,%player)
{
	%initialPos = %brick.getPosition();
	%stack = new SimSet();
	%stack.add(%brick);
	%stack.brick0 = %brick.toSaveStr(%initialPos);
	if(!%brick.getDatablock().IsLogicBrick && !%brick.getDatablock().IsGate) //marble's hack because logic bricks lel
	{
	  if(isEventPending(%brick.highlightColorReset))
		 cancel(%brick.highlightColorReset);
	  else
	  {
		 %color = %brick.getColorID();
		 %colorFX = %brick.getColorFxID();
		 %brick.setColor($Pref::PropifyWand::HighlightColor);
		 %brick.setColorFX(3);
		 %brick.originalColor = %color;
		 %brick.originalColorFX = %colorFX;
	  }
	  %brick.highlightColorReset = %brick.schedule(3000,restoreOrignalColors);
	}
	%final = 1;
	for(%current = 0; %current != %final; %current++)
	{
		if((%player.client.isAdmin && $Pref::PropifyWand::MaxBricks <= %stack.getCount()) || (!%player.client.isAdmin && $Pref::PropifyWand::MaxBricksB <= %stack.getCount()))
		{
			%stack.err = "Limit";
			return %stack;
		}
		%brick = %stack.getObject(%current);
		if(%current)
		{
			for(%i=0;%i<%brick.getNumDownBricks();%i++)
			{
				%appendBrick = %brick.getDownBrick(%i);
				if(%stack.isMember(%appendBrick))
					continue;
			if(!%brick.getDatablock().IsLogicBrick && !%brick.getDatablock().IsGate)
			{
			   if(isEventPending(%appendBrick.highlightColorReset))
				  cancel(%appendBrick.highlightColorReset);
			   else
			   {
				  %color = %appendBrick.getColorID();
				  %colorFX = %appendBrick.getColorFxID();
				  %appendBrick.setColor($Pref::PropifyWand::HighlightColor);
				  %appendBrick.setColorFX(3);
				  %appendBrick.originalColor = %color;
				  %appendBrick.originalColorFX = %colorFX;
			   }
			   %appendBrick.highlightColorReset = %appendBrick.schedule(3000,restoreOrignalColors);
			}
				%stack.add(%appendBrick);
				%stack.brick[%stack.getCount()-1] = %appendBrick.toSaveStr(%initialPos);
				%final++;
			}
		}
		for(%i=0;%i<%brick.getNumUpBricks();%i++)
		{
			%appendBrick = %brick.getUpBrick(%i);
			if(%stack.isMember(%appendBrick))
					continue;
		 if(!%brick.getDatablock().IsLogicBrick && !%brick.getDatablock().IsGate)
		 {
			if(isEventPending(%appendBrick.highlightColorReset))
			   cancel(%appendBrick.highlightColorReset);
			else
			{
			   %color = %appendBrick.getColorID();
			   %colorFX = %appendBrick.getColorFxID();
			   %appendBrick.setColor($Pref::PropifyWand::HighlightColor);
			   %appendBrick.setColorFX(3);
			   %appendBrick.originalColor = %color;
			   %appendBrick.originalColorFX = %colorFX;
			}
			%appendBrick.highlightColorReset = %appendBrick.schedule(3000,restoreOrignalColors);
		 }
			%stack.add(%appendBrick);
			%stack.brick[%stack.getCount()-1] = %appendBrick.toSaveStr(%initialPos);
			%final++;
		}
	}
	return %stack;
}
function servercmdPropifyWand(%client)
{
	if(!%client.isAdmin && $Pref::PropifyWand::AdminOnly)
	{
		commandToClient(%client,'centerPrint',"<color:FF9900>You must be an \c3Admin<color:FF9900> to use the <color:ffa500>Propify Wand",3);
		return;
	}

	if(!isObject(%client.player))
		return;
	%client.player.updateArm(PropifyWandImage);
	%client.player.mountImage(PropifyWandImage,0);
}
function servercmdPropWand(%client)
{
	servercmdPropifyWand(%client);
}